#include <hxcpp.h>

#ifndef INCLUDED_snow_types_InputEventType
#include <snow/types/InputEventType.h>
#endif
namespace snow{
namespace types{

::snow::types::InputEventType InputEventType_obj::controller;

::snow::types::InputEventType InputEventType_obj::joystick;

::snow::types::InputEventType InputEventType_obj::key;

::snow::types::InputEventType InputEventType_obj::mouse;

::snow::types::InputEventType InputEventType_obj::touch;

::snow::types::InputEventType InputEventType_obj::unknown;

HX_DEFINE_CREATE_ENUM(InputEventType_obj)

int InputEventType_obj::__FindIndex(::String inName)
{
	if (inName==HX_CSTRING("controller")) return 5;
	if (inName==HX_CSTRING("joystick")) return 4;
	if (inName==HX_CSTRING("key")) return 1;
	if (inName==HX_CSTRING("mouse")) return 2;
	if (inName==HX_CSTRING("touch")) return 3;
	if (inName==HX_CSTRING("unknown")) return 0;
	return super::__FindIndex(inName);
}

int InputEventType_obj::__FindArgCount(::String inName)
{
	if (inName==HX_CSTRING("controller")) return 0;
	if (inName==HX_CSTRING("joystick")) return 0;
	if (inName==HX_CSTRING("key")) return 0;
	if (inName==HX_CSTRING("mouse")) return 0;
	if (inName==HX_CSTRING("touch")) return 0;
	if (inName==HX_CSTRING("unknown")) return 0;
	return super::__FindArgCount(inName);
}

Dynamic InputEventType_obj::__Field(const ::String &inName,bool inCallProp)
{
	if (inName==HX_CSTRING("controller")) return controller;
	if (inName==HX_CSTRING("joystick")) return joystick;
	if (inName==HX_CSTRING("key")) return key;
	if (inName==HX_CSTRING("mouse")) return mouse;
	if (inName==HX_CSTRING("touch")) return touch;
	if (inName==HX_CSTRING("unknown")) return unknown;
	return super::__Field(inName,inCallProp);
}

static ::String sStaticFields[] = {
	HX_CSTRING("unknown"),
	HX_CSTRING("key"),
	HX_CSTRING("mouse"),
	HX_CSTRING("touch"),
	HX_CSTRING("joystick"),
	HX_CSTRING("controller"),
	::String(null()) };

static void sMarkStatics(HX_MARK_PARAMS) {
	HX_MARK_MEMBER_NAME(InputEventType_obj::controller,"controller");
	HX_MARK_MEMBER_NAME(InputEventType_obj::joystick,"joystick");
	HX_MARK_MEMBER_NAME(InputEventType_obj::key,"key");
	HX_MARK_MEMBER_NAME(InputEventType_obj::mouse,"mouse");
	HX_MARK_MEMBER_NAME(InputEventType_obj::touch,"touch");
	HX_MARK_MEMBER_NAME(InputEventType_obj::unknown,"unknown");
};

#ifdef HXCPP_VISIT_ALLOCS
static void sVisitStatic(HX_VISIT_PARAMS) {
	HX_VISIT_MEMBER_NAME(InputEventType_obj::__mClass,"__mClass");
	HX_VISIT_MEMBER_NAME(InputEventType_obj::controller,"controller");
	HX_VISIT_MEMBER_NAME(InputEventType_obj::joystick,"joystick");
	HX_VISIT_MEMBER_NAME(InputEventType_obj::key,"key");
	HX_VISIT_MEMBER_NAME(InputEventType_obj::mouse,"mouse");
	HX_VISIT_MEMBER_NAME(InputEventType_obj::touch,"touch");
	HX_VISIT_MEMBER_NAME(InputEventType_obj::unknown,"unknown");
};
#endif

static ::String sMemberFields[] = { ::String(null()) };
Class InputEventType_obj::__mClass;

Dynamic __Create_InputEventType_obj() { return new InputEventType_obj; }

void InputEventType_obj::__register()
{

hx::Static(__mClass) = hx::RegisterClass(HX_CSTRING("snow.types.InputEventType"), hx::TCanCast< InputEventType_obj >,sStaticFields,sMemberFields,
	&__Create_InputEventType_obj, &__Create,
	&super::__SGetClass(), &CreateInputEventType_obj, sMarkStatics
#ifdef HXCPP_VISIT_ALLOCS
    , sVisitStatic
#endif
#ifdef HXCPP_SCRIPTABLE
    , 0
#endif
);
}

void InputEventType_obj::__boot()
{
hx::Static(controller) = hx::CreateEnum< InputEventType_obj >(HX_CSTRING("controller"),5);
hx::Static(joystick) = hx::CreateEnum< InputEventType_obj >(HX_CSTRING("joystick"),4);
hx::Static(key) = hx::CreateEnum< InputEventType_obj >(HX_CSTRING("key"),1);
hx::Static(mouse) = hx::CreateEnum< InputEventType_obj >(HX_CSTRING("mouse"),2);
hx::Static(touch) = hx::CreateEnum< InputEventType_obj >(HX_CSTRING("touch"),3);
hx::Static(unknown) = hx::CreateEnum< InputEventType_obj >(HX_CSTRING("unknown"),0);
}


} // end namespace snow
} // end namespace types
